"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CompareNavBarAppearanceCombinedConfig = exports.CompareLegacyAppearanceConfig = exports.CompareNavBarAppearanceConfig = exports.CompareNavBarAppearance = void 0;

var _CompareUtilities = require("./CompareUtilities");

var _CompareImageConfig = require("./CompareImageConfig");

var _CompareMisc = require("./CompareMisc");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class CompareNavBarAppearance {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(CompareNavBarAppearance.propertyMap, oldItem, newItem, true);
    ;
  }

}

exports.CompareNavBarAppearance = CompareNavBarAppearance;

_defineProperty(CompareNavBarAppearance, "propertyMap", {
  // shallow compare
  baseConfig: {
    mode: 'shallow'
  },
  backgroundEffect: {
    mode: 'shallow'
  },
  backgroundColor: {
    mode: 'shallow'
  },
  backgroundImageContentMode: {
    mode: 'shallow'
  },
  shadowColor: {
    mode: 'shallow'
  },
  titlePositionAdjustment: {
    mode: 'shallow'
  },
  // shallow compare object
  titleTextAttributes: {
    mode: 'shallowObject'
  },
  largeTitleTextAttributes: {
    mode: 'shallowObject'
  },
  backIndicatorImage: {
    mode: 'custom',
    customCompare: _CompareImageConfig.CompareImageConfig.compare
  },
  // custom compare
  backgroundImage: {
    mode: 'custom',
    customCompare: _CompareImageConfig.CompareImageConfig.compare
  },
  shadowImage: {
    mode: 'custom',
    customCompare: _CompareImageConfig.CompareImageConfig.compare
  }
});

;

class CompareNavBarAppearanceConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(this.propertyMap, oldItem, newItem, true);
  }

}

exports.CompareNavBarAppearanceConfig = CompareNavBarAppearanceConfig;

_defineProperty(CompareNavBarAppearanceConfig, "propertyMap", {
  // shallow compare 
  navBarPreset: {
    mode: 'shallow'
  },
  // custom compare
  standardAppearance: {
    mode: 'custom',
    customCompare: CompareNavBarAppearance.compare
  },
  compactAppearance: {
    mode: 'custom',
    customCompare: CompareNavBarAppearance.compare
  },
  scrollEdgeAppearance: {
    mode: 'custom',
    customCompare: CompareNavBarAppearance.compare
  }
});

;

class CompareLegacyAppearanceConfig {
  static compare(oldItem, newItem) {
    return _CompareUtilities.CompareUtilities.compareObject(CompareLegacyAppearanceConfig.propertyMap, oldItem, newItem, true);
  }

}

exports.CompareLegacyAppearanceConfig = CompareLegacyAppearanceConfig;

_defineProperty(CompareLegacyAppearanceConfig, "propertyMap", {
  // shallow compare 
  barStyle: {
    mode: 'shallow'
  },
  navBarPreset: {
    mode: 'shallow'
  },
  // shallow object compare
  barTintColor: {
    mode: 'shallowObject'
  },
  titleTextAttributes: {
    mode: 'shallowObject'
  },
  largeTitleTextAttributes: {
    mode: 'shallowObject'
  },
  backgroundImage: {
    mode: 'deep'
  },
  titleVerticalPositionAdjustment: {
    mode: 'deep'
  },
  // custom compare
  backIndicatorImage: {
    mode: 'custom',
    customCompare: _CompareImageConfig.CompareImageConfig.compare
  },
  shadowImage: {
    mode: 'custom',
    customCompare: _CompareImageConfig.CompareImageConfig.compare
  },
  tintColor: {
    mode: 'custom',
    customCompare: _CompareMisc.compareColor
  }
});

;

class CompareNavBarAppearanceCombinedConfig {
  static compare(oldItem, newItem) {
    return oldItem.mode === newItem.mode && oldItem.navBarPreset === newItem.navBarPreset && (oldItem.mode === 'legacy' ? CompareLegacyAppearanceConfig.compare(oldItem, newItem) : CompareNavBarAppearanceConfig.compare(oldItem, newItem));
  }

}

exports.CompareNavBarAppearanceCombinedConfig = CompareNavBarAppearanceCombinedConfig;
;
//# sourceMappingURL=CompareNavBarAppearanceCombinedConfig.js.map