function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import fastDeepEqual from "fast-deep-equal";
import { CompareUtilities } from './CompareUtilities';

function comparePointOrPointPreset(oldItem, newItem) {
  if (typeof oldItem === 'string') {
    return oldItem === newItem;
  }

  ;
  return CompareUtilities.shallowCompareObject(oldItem, newItem);
}

;
export class CompareImageGradientConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(CompareImageGradientConfig.propertyMap, oldItem, newItem);
  }

}

_defineProperty(CompareImageGradientConfig, "propertyMap", {
  type: {
    mode: 'shallow'
  },
  width: {
    mode: 'shallow'
  },
  height: {
    mode: 'shallow'
  },
  borderRadius: {
    mode: 'shallow'
  },
  colors: {
    mode: 'shallowArray'
  },
  locations: {
    mode: 'shallowArray'
  },
  startPoint: {
    mode: 'custom',
    customCompare: comparePointOrPointPreset
  },
  endPoint: {
    mode: 'custom',
    customCompare: comparePointOrPointPreset
  }
});

;
export class CompareImageRectConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(this.propertyMap, oldItem, newItem);
  }

}

_defineProperty(CompareImageRectConfig, "propertyMap", {
  width: {
    mode: 'shallow'
  },
  height: {
    mode: 'shallow'
  },
  fillColor: {
    mode: 'shallow'
  },
  borderRadius: {
    mode: 'shallow'
  }
});

;
export class CompareImageConfig {
  static compare(oldItem, newItem) {
    if (oldItem.type !== newItem.type) return false;

    switch (oldItem.type) {
      case 'IMAGE_ASSET':
      case 'IMAGE_SYSTEM':
        return oldItem.imageValue === newItem.imageValue;

      case 'IMAGE_RECT':
        return CompareImageRectConfig.compare(oldItem.imageValue, newItem.imageValue);

      case 'IMAGE_GRADIENT':
        return CompareImageGradientConfig.compare(oldItem.imageValue, newItem.imageValue);

      case 'IMAGE_REQUIRE':
      default:
        return fastDeepEqual(oldItem, newItem);
    }

    ;
  }

}
;
//# sourceMappingURL=CompareImageConfig.js.map