function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { CompareUtilities } from './CompareUtilities';
import { CompareImageConfig } from './CompareImageConfig';
import { compareColor } from './CompareMisc';
export class CompareNavBarAppearance {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(CompareNavBarAppearance.propertyMap, oldItem, newItem, true);
    ;
  }

}

_defineProperty(CompareNavBarAppearance, "propertyMap", {
  // shallow compare
  baseConfig: {
    mode: 'shallow'
  },
  backgroundEffect: {
    mode: 'shallow'
  },
  backgroundColor: {
    mode: 'shallow'
  },
  backgroundImageContentMode: {
    mode: 'shallow'
  },
  shadowColor: {
    mode: 'shallow'
  },
  titlePositionAdjustment: {
    mode: 'shallow'
  },
  // shallow compare object
  titleTextAttributes: {
    mode: 'shallowObject'
  },
  largeTitleTextAttributes: {
    mode: 'shallowObject'
  },
  backIndicatorImage: {
    mode: 'custom',
    customCompare: CompareImageConfig.compare
  },
  // custom compare
  backgroundImage: {
    mode: 'custom',
    customCompare: CompareImageConfig.compare
  },
  shadowImage: {
    mode: 'custom',
    customCompare: CompareImageConfig.compare
  }
});

;
export class CompareNavBarAppearanceConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(this.propertyMap, oldItem, newItem, true);
  }

}

_defineProperty(CompareNavBarAppearanceConfig, "propertyMap", {
  // shallow compare 
  navBarPreset: {
    mode: 'shallow'
  },
  // custom compare
  standardAppearance: {
    mode: 'custom',
    customCompare: CompareNavBarAppearance.compare
  },
  compactAppearance: {
    mode: 'custom',
    customCompare: CompareNavBarAppearance.compare
  },
  scrollEdgeAppearance: {
    mode: 'custom',
    customCompare: CompareNavBarAppearance.compare
  }
});

;
export class CompareLegacyAppearanceConfig {
  static compare(oldItem, newItem) {
    return CompareUtilities.compareObject(CompareLegacyAppearanceConfig.propertyMap, oldItem, newItem, true);
  }

}

_defineProperty(CompareLegacyAppearanceConfig, "propertyMap", {
  // shallow compare 
  barStyle: {
    mode: 'shallow'
  },
  navBarPreset: {
    mode: 'shallow'
  },
  // shallow object compare
  barTintColor: {
    mode: 'shallowObject'
  },
  titleTextAttributes: {
    mode: 'shallowObject'
  },
  largeTitleTextAttributes: {
    mode: 'shallowObject'
  },
  backgroundImage: {
    mode: 'deep'
  },
  titleVerticalPositionAdjustment: {
    mode: 'deep'
  },
  // custom compare
  backIndicatorImage: {
    mode: 'custom',
    customCompare: CompareImageConfig.compare
  },
  shadowImage: {
    mode: 'custom',
    customCompare: CompareImageConfig.compare
  },
  tintColor: {
    mode: 'custom',
    customCompare: compareColor
  }
});

;
export class CompareNavBarAppearanceCombinedConfig {
  static compare(oldItem, newItem) {
    return oldItem.mode === newItem.mode && oldItem.navBarPreset === newItem.navBarPreset && (oldItem.mode === 'legacy' ? CompareLegacyAppearanceConfig.compare(oldItem, newItem) : CompareNavBarAppearanceConfig.compare(oldItem, newItem));
  }

}
;
//# sourceMappingURL=CompareNavBarAppearanceCombinedConfig.js.map