import type { NativePushPopOptions } from "../native_modules/RNINavigatorViewModule";
declare type RouteTransitionConfigBase = {
    duration?: number;
};
export declare enum RouteTransitionPushTypesEnum {
    DefaultPush = "DefaultPush",
    FadePush = "FadePush",
    SlideLeftPush = "SlideLeftPush",
    SlideUpPush = "SlideUpPush",
    GlideUpPush = "GlideUpPush",
    ZoomFadePush = "ZoomFadePush",
    FlipHorizontalPush = "FlipHorizontalPush",
    FlipVerticalPush = "FlipVerticalPush"
}
export declare enum RouteTransitionPopTypesEnum {
    DefaultPop = "DefaultPop",
    FadePop = "FadePop",
    SlideLeftPop = "SlideLeftPop",
    SlideUpPop = "SlideUpPop",
    GlideUpPop = "GlideUpPop",
    ZoomFadePop = "ZoomFadePop",
    FlipHorizontalPop = "FlipHorizontalPop",
    FlipVerticalPop = "FlipVerticalPop"
}
export declare type RouteTransitionPushTypes = keyof typeof RouteTransitionPushTypesEnum;
export declare type RouteTransitionPopTypes = keyof typeof RouteTransitionPopTypesEnum;
export declare type RouteTransitionPushConfig = RouteTransitionConfigBase & {
    type: RouteTransitionPushTypesEnum | RouteTransitionPushTypes;
};
export declare type RouteTransitionPopConfig = RouteTransitionConfigBase & {
    type: RouteTransitionPopTypesEnum | RouteTransitionPopTypes;
};
export declare type NavCommandPushOptions = NativePushPopOptions & {
    transitionConfig?: RouteTransitionPushConfig;
};
export declare type NavCommandPopOptions = NativePushPopOptions & {
    transitionConfig?: RouteTransitionPopConfig;
};
export {};
